﻿Imports SnippsCode.dsSnippsCode
Public Class frmMain
    Private _mouseOffset As Point
    Private f As New SnippFunction
#Region "Form"
    Private Sub frmMain_Load(sender As Object, e As EventArgs) Handles Me.Load
        If My.Settings.firstStart Then
            Dim parentRow = Dts.ProjektOrdner.AddProjektOrdnerRow("AboutSnippsCode")
            Dts.ProjektDatei.AddProjektDateiRow(parentRow, "ReadMe", My.Resources.ReadMe)
            Dts.ProjektDatei.AddProjektDateiRow(parentRow, "ToDo", My.Resources.ToDo)
            f.Reload(Dts)
        Else
            f.Load(Dts)
        End If
        generateToolTips()
        scExplorer.SplitterWidth = 2
    End Sub
    Private Sub frmMain_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        Me.Validate()
        f.Save(Dts)
    End Sub
    Private Sub frmMain_FormClosed(sender As Object, e As FormClosedEventArgs) Handles Me.FormClosed
        Me.SuspendLayout()
        With Me.Controls
            While .Count > 0 : .Item(.Count - 1).Dispose() : End While
        End With
    End Sub
    Private Sub ctrMouseEvent_MouseDown(sender As Object, e As MouseEventArgs) Handles Me.MouseDown, panTop.MouseDown, lblTitle.MouseDown
        Select Case True
            Case sender Is Me, sender Is panTop, sender Is lblTitle
                _mouseOffset = New Point(-e.X, -e.Y)
        End Select
    End Sub
    Private Sub ctrlMouseEvent_MouseMove(sender As Object, e As MouseEventArgs) Handles Me.MouseMove, panTop.MouseMove, lblTitle.MouseMove
        Select Case True
            Case sender Is Me, sender Is panTop, sender Is lblTitle
                If e.Button = MouseButtons.Left Then
                    Dim mousePos = Control.MousePosition
                    mousePos.Offset(_mouseOffset.X, _mouseOffset.Y)
                    Location = mousePos
                End If
        End Select
    End Sub
#End Region
#Region "DGV´s"
    Private Sub dgvProject_CellValidating(sender As Object, e As DataGridViewCellValidatingEventArgs) Handles dgvProject.CellValidating
        If (String.IsNullOrEmpty(e.FormattedValue.ToString())) Then e.Cancel = True
    End Sub
    Private Sub dgvSnippets_CellValidating(sender As Object, e As DataGridViewCellValidatingEventArgs) Handles dgvSnippets.CellValidating
        If (String.IsNullOrEmpty(e.FormattedValue.ToString())) Then e.Cancel = True
    End Sub
    Private Sub dgvMouseWheel(sender As Object, e As MouseEventArgs) Handles dgvProject.MouseWheel, dgvSnippets.MouseWheel
        Select Case True
            Case sender Is dgvProject
                dgvProject.dgvMouse_Wheel(e.Delta)
            Case sender Is dgvSnippets
                dgvSnippets.dgvMouse_Wheel(e.Delta)
        End Select
    End Sub
    Private Sub dgvSnippets_KeyDown(sender As Object, e As KeyEventArgs) Handles dgvSnippets.KeyDown
        If e.KeyCode = Keys.Back OrElse e.KeyCode = Keys.Delete Then
            Using fMes As New frmMSG
                fMes.lblTitle.Text = "Projekt Datei löschen..."
                If dgvSnippets.Rows.Count > 0 Then
                    If fMes.ShowDialog(Me) = DialogResult.OK Then
                        dgvSnippets.Rows.Remove(dgvSnippets.CurrentRow)
                        Me.Validate()
                        f.Save(Dts)
                    End If
                Else
                    Return
                End If
            End Using
        Else
            Return
        End If
    End Sub
    Private Sub dgvProject_KeyDown(sender As Object, e As KeyEventArgs) Handles dgvProject.KeyDown
        If e.KeyCode = Keys.Back OrElse e.KeyCode = Keys.Delete Then
            Using fMes As New frmMSG
                fMes.lblTitle.Text = "Projekt Ordner löschen..."
                If dgvProject.Rows.Count > 1 Then
                    If fMes.ShowDialog(Me) = DialogResult.OK Then
                        dgvProject.Rows.Remove(dgvProject.CurrentRow)
                        Me.Validate()
                        f.Save(Dts)
                    End If
                Else
                    Return
                End If

            End Using
        Else
            Return
        End If
    End Sub
    Private Sub CheckedChanged(sender As Object, e As EventArgs) Handles chkBSFile.CheckedChanged, chkBSProject.CheckedChanged, chkNumberLines.CheckedChanged
        Select Case True
            Case sender Is chkBSProject
                If chkBSProject.Checked Then
                    chkBSProject.Image = My.Resources.filterClear
                Else
                    chkBSProject.Image = My.Resources.filterEmpty
                    bsProject.Filter = ""
                End If
            Case sender Is chkBSFile
                If chkBSFile.Checked Then
                    chkBSFile.Image = My.Resources.filterClear
                Else
                    chkBSFile.Image = My.Resources.filterEmpty
                    bsFile.Filter = ""
                End If
            Case sender Is chkNumberLines
                If chkNumberLines.Checked Then
                    lblNumberLines.SetLineNum(rtbSnippet)
                Else
                    lblNumberLines.Text = ""
                End If
        End Select
        panSearch.Visible = chkBSFile.Checked OrElse chkBSProject.Checked
        txtSearch.Select()
    End Sub
    Private Sub txtSearch_TextChanged(sender As Object, e As EventArgs) Handles txtSearch.TextChanged
        Dim searchText As String = txtSearch.Text
        If chkBSFile.Checked Then
            bsFile.Filter = "Name like '%" & searchText & "%'"
        Else
            bsProject.Filter = "Name like '%" & searchText & "%'"
        End If
    End Sub
#End Region
#Region "Subs"
    Private Sub Import()
        Using ofd As New OpenFileDialog With {.Filter = My.Resources.ofdFilter}
            If ofd.ShowDialog <> DialogResult.OK Then Return
            If ofd.FileName.EndsWith(".snp") Then
                f.ImportFromSnippsCode(ofd.FileName)
            ElseIf ofd.FileName.EndsWith(".xml") Then
                f.ImportFromSnipps(ofd.FileName)
            Else
                f.ImportFromFile(ofd.FileName)
            End If
        End Using
        f.Save(Dts)
        If f._NotImportedList.Count > 0 Then
            Using frm As New frmImport
                frm.lstNotImported.DataSource = f._NotImportedList
                frm.ShowDialog()
            End Using
            f._NotImportedList.Clear()
        End If
    End Sub
    Private Sub Export()
        Using fbd As New FolderBrowserDialog With {.Description = "Bitte wählen Sie den Speicherort für SnippsCode Datei...", .ShowNewFolderButton = True}
            If fbd.ShowDialog <> DialogResult.OK Then Return
            f.Save(Dts, False, New IO.FileInfo(fbd.SelectedPath & "\SnippsCode.snp"))
        End Using
    End Sub
    Private Sub ExportToFile()
        Dim rw = DirectCast(bsFile.Current, DataRowView)
        Dim fName = DirectCast(rw.Row, ProjektDateiRow)
        Using sfd As New SaveFileDialog With {.Title = "Bitte wählen Sie Ihren Pfad...", .Filter = My.Resources.ofdFilter, .FileName = fName.Name}
            If sfd.ShowDialog <> DialogResult.OK Then Return
            f.ExportToFile(sfd.FileName, rtbSnippet.Text)
        End Using
    End Sub
    Private Sub fResize()
        If MyBase.WindowState = FormWindowState.Maximized Then
            MyBase.WindowState = FormWindowState.Normal
            btnMax.Image = My.Resources.MaximizeWindow
        Else
            MyBase.WindowState = FormWindowState.Maximized
            btnMax.Image = My.Resources.RestoreWindow
        End If
    End Sub
    Private Sub copyText()
        If rtbSnippet.Text.Length = 0 Then Return
        If rtbSnippet.SelectedText.Length = 0 Then rtbSnippet.SelectAll()
        Clipboard.SetText(rtbSnippet.SelectedText)
    End Sub
    Private Sub Backup()
        f.Save(Dts, True)
        If f._BackupSuccess Then
            niMain.Visible = True
            niMain.ShowBalloonTip(2)
            niMain.Visible = False
        End If
    End Sub
    Private Sub showDragDrop()
        Using f As New frmDrop
            Me.Visible = False
            If f.ShowDialog() = DialogResult.OK Then Me.Visible = True
        End Using
    End Sub
    Private Sub generateToolTips()
        Dim btnToolTip As New ToolTip
        btnToolTip.AutoPopDelay = 5000
        btnToolTip.InitialDelay = 500
        btnToolTip.ReshowDelay = 500
        btnToolTip.ShowAlways = True
        btnToolTip.SetToolTip(btnUnDo, "Rückgängig")
        btnToolTip.SetToolTip(btnRedo, "Wiederholen")
        btnToolTip.SetToolTip(btnCopy, "Text kopieren")
        btnToolTip.SetToolTip(btnDelSpace, "Leerzeilen entfernen")
        btnToolTip.SetToolTip(chkBSFile, "Filter Ein/Aus")
        btnToolTip.SetToolTip(chkBSProject, "Filter Ein/Aus")
        btnToolTip.SetToolTip(btnAddProject, "Neues Projekt")
        btnToolTip.SetToolTip(btnAddFile, "Neue Projektdatei")
        btnToolTip.SetToolTip(chkNumberLines, "Zeilennummerierung")
        btnToolTip.SetToolTip(btnTxtExport, "Inhalt Exportieren")
    End Sub
#End Region
#Region "Buttons"
    Private Sub Button_Pressed(ByVal sender As Object, ByVal e As EventArgs) Handles btnSave.Click, btnUpdate.Click, btnAddProject.Click, btnAddFile.Click, btnAbout.Click,
        btnUnDo.Click, btnRedo.Click, btnCopy.Click, btnDelSpace.Click, btnClearFilter.Click, btnBackup.Click, btnMax.Click, btnMini.Click, btnClose.Click, btnDrag.Click,
        btnImport.Click, btnExport.Click, btnTxtExport.Click
        Select Case True
            Case sender Is btnClose : Me.Close()
            Case sender Is btnMax
                fResize()
            Case sender Is btnMini : MyBase.WindowState = FormWindowState.Minimized
            Case sender Is btnAddProject
                bsProject.AddNew()
                dgvProject.BeginEdit(True)
            Case sender Is btnAddFile
                bsFile.AddNew()
                dgvSnippets.BeginEdit(True)
            Case sender Is btnSave
                f.Save(Dts)
            Case sender Is btnAbout
                frmAbout.ShowDialog(Me)
            Case sender Is btnUpdate
                ucSnippsCode.updateInteractive(Me)
            Case sender Is btnCopy
                copyText()
            Case sender Is btnDelSpace
                rtbSnippet.Text = rtbSnippet.Text.DeleteLines
            Case sender Is btnUnDo
                rtbSnippet.rUnDo
            Case sender Is btnRedo
                rtbSnippet.rReDo
            Case sender Is btnClearFilter
                txtSearch.Text = ""
            Case sender Is btnBackup
                Backup()
            Case sender Is btnDrag
                showDragDrop()
            Case sender Is btnImport
                Import()
            Case sender Is btnExport
                Export()
            Case sender Is btnTxtExport
                ExportToFile()
        End Select
    End Sub

    Private Sub rtbSnippet_VScroll(sender As Object, e As EventArgs) Handles rtbSnippet.VScroll
        If chkNumberLines.Checked Then lblNumberLines.SetLineNum(rtbSnippet) Else lblNumberLines.Text = ""
    End Sub

    Private Sub rtbSnippet_TextChanged(sender As Object, e As EventArgs) Handles rtbSnippet.TextChanged
        If chkNumberLines.Checked Then lblNumberLines.SetLineNum(rtbSnippet) Else lblNumberLines.Text = ""
    End Sub
#End Region
End Class
